       program rt_input
c      ***********************************************************************
c      function-  this program is the first part of the interface
c                 program for RT programs
c      modifications
c        20060715 - changes in subroutine ozn3_abs to avoid small taa in lowest layers
c      modifications
c        20060715 - taa is equal in 2 lowest layers
c      ***********************************************************************
c
      include 'rtinput.cmn'
      character*60 dir1,dir2,dir3,tmat,tmat55,out2,out3,out23
      character*3  cndex,gndex
      character*2  dndex,endex,wwcc,fndex
      character*80 txt
c
      open (5,file='dir.dat',status='old')
      read (5,'(a)') dir1
      read (5,'(a)') dir2
      read (5,'(a)') dir3
      len1 = index(dir1,' ')-1
      len2 = index(dir2,' ')-1
      len3 = index(dir3,' ')-1
c     -- open files
c     open (unit=6,file='dump',status='unknown')
      open (unit=4,file=dir1(1:len1)//'input.dat',status='old') 
      open (unit=7,file=dir1(1:len1)//'ozone101.dat',status='old')
      open (unit=8,file=dir1(1:len1)//'atm_prof_vpd.dat',
     1      status='old')
      open (unit=15,file=dir1(1:len1)//'coeff_abs.dat',status='old')
c     -- read flags and other processing parameters
      read (4,1002) txt
      read (4,1000) (iair(i),i=1,3),idust,iaprof,icld
      if (idust.eq.0 .and. iaprof.eq.0 ) then
        iaprof=1
        idust=0
      endif
      if (idust.eq.1 .and. iaprof.eq.1 ) then
        iaprof=1
        idust=0
      endif
      read (4,1002) txt
      read (4,1003) nch,nt55,nortau,ioznab,nrmww,ncloud
      call convtc(nrmww,2,wwcc)
      read (4,1065) ilam1,ilam2
      read (4,1065) isd1,isd2
      read (4,1065) itau1,itau2
      read (4,1065) icld1,icld2
      if (iair(2).eq.0) then
        isd1  = 1
        isd2  = 1
        itau1 = 1
        itau2 = 1
      endif
      if (icld.eq.0) then
        icld1  = 1
        icld2  = 1
        ncloud = 1
      endif
      read (4,1002) txt
      read (4,1015) deltau,psrfc,ht_dust,sigma_dust
      write (6,*)   deltau,psrfc,ht_dust,sigma_dust
      read (4,1002) txt
      read (4,1005) (taum55(i),i=1,nt55)  !read aerosol optical thkns
      if (icld.eq.1) then
        read (4,1002) txt
        read (4,1015) pcldtop,pcldbtm    !pressure in units of atm.
        read (4,1002) txt
        read (4,1007) (taucloud(i),i=1,ncloud)     !read cloud opt thick
        write (*,*) 'taucloud',taucloud
        read (4,1002) txt
        read (4,*) (dtaucloud(i),i=1,ncloud)    !thickness of a cloud layer
        write (*,*) 'dtaucloud',dtaucloud
      endif
c     -- read wavelenghts, rayleigh scattering coeff., and absorption
c     -- coefficients for ozone, and molecular depolarization
c     -- factors.  
c     -- ioznab=0   input is ozone optical thickness
c     -- ioznab=1   input is ozone absorption coeff at temp t
c     -- ioznab=2   input is ozone absorption at t=0c and the temp.
c     --            dependent coeff.  the input is read from a dataset:
c     --            coeff.dat.
c
      read (15,1002) txt
      do kz=1,nch
        read (15,*) kznum,xlamb(kz),c0(kz),c1(kz),c2(kz),
     1              beta(kz),rho(kz)
      enddo
      do i=1,koznp
        read (7,*)ppo(i),x101(i),temp101(i)
      enddo
      do i=1,kozn
        dx(i)=(x101(i+1)-x101(i))*1.0d-3
      enddo
      ijkozn = x101(koznp)+0.0001d0
c     -- read height, pressure, ozone, and aerosol number density from
c     -- a datatset which is used currently in the vpd program
c     -- the dataset name is atmos_prof_vpd
      do i=1,kmac
        read (8,*) htdd(i),ppodd(i),dxdd(i),znpdd(i)
      enddo
      if (idust.eq.1) call dust_prof
c     -- store top of the atmosphere in buffer element 1 and bottom in kmac
      do i=1,kmac                                                    
        k = kmac - i + 1                                            
        ppod(i) = ppodd(k) / ppodd(1)                                   
        htd(i)  = htdd(k)
        znp(i)  = znpdd(k)
        dxd(i)  = dxdd(k)
      enddo                                                          
c     -- create output datasets for modis like aerosol look-up tables.
      call convtc(ijkozn,3,gndex)
      do il = ilam1,ilam2,1                                            
        do isd = isd1,isd2,1
          do itau = itau1,itau2,1
            do mcld = icld1,icld2
c                                                                       
              call convtc(il,3,cndex)                                 
              call convtc(isd,2,dndex)                               
              call convtc(itau,2,endex)                             
              call convtc(mcld,2,fndex)
c                                                                       
              out2='L'//cndex//'s'//dndex//'ta'//endex//'tc'//fndex//
     1        'oz'//gndex//'.out' 
              out3='spl'//cndex//'s'//dndex//'t'//endex//'.dat'
              tmat='tl'//cndex//'s'//dndex//'.dat'
              out23='L'//cndex//'s'//dndex//'ta'//endex//'tc'//fndex//
     1       'oz'//gndex//'.dat'
              tmat55='tl'//wwcc//'s'//dndex//'.dat'
c
              n02 = index(out2,' ')-1
              n03 = index(out3,' ')-1
              ntm = index(tmat,' ')-1
c             n21 = index(out21,' ')-1
              n23 = index(out23,' ')-1
              n55 = index(tmat55,' ')-1
c
              open(2,status='scratch')
              open(unit=23,file=dir2(1:len2)//out23(1:n23),
     1             status='unknown')
c             -- convert wavelength in cm
              wvlth  = xlamb(il)/10000.0d0                         
              tr     = beta(il)                                   
              tozn   = ttozn(il)
              cc0    = c0(il)
              cc1    = c1(il)
              cc2    = c2(il)
              rrho   = rho(il)
              taucld = taucloud(mcld)
              dltcld = dtaucloud(mcld)
              kcld   = icld
              if (taucld.lt.1.0e-5) kcld=0
              ifc = 0                                            
              if (iair(2) .eq. 1) ifc=1                        
              if (taum55(itau).lt. 1.0d-6) ifc=0
c             -- set  scattering and extinction coefficients 
c             -- equal to 1.0e-15          
              qst = 1.0e-15                                           
              qtt = 1.0e-15                                          
c             -- if aerosol is present then read in the t matrix          
              if (iair(2) .eq. 1) then 
                open(unit=9,file=dir3(1:len3)//tmat(1:ntm),status='old')
                read (9,1090) txt
                read (9,1090) txt
                read (9,1095) ifunc1,mfunc1
                read (9,1090) txt
                read (9,1100) wvlth2
                read (9,1090) txt
                read (9,1090) txt
                read (9,1090) txt
                read (9,1090) txt
                read (9,1090) txt
                read (9,1090) txt
                read (9,1090) txt
                read (9,1090) txt
                read (9,1090) txt
                read (9,1100) ccn,bsr,salb,asf,qst,qtt
                wvlth2=wvlth2*1.0e-4
                dwv=dabs(wvlth2-wvlth)
                if (dwv .ge.1.0e-8) then
                  write(2,1105)wvlth,wvlth2
                  stop
                endif
                close (9)
c               -- if nortau=1 then read scattering and extinction coeff
c               -- for the reference wavelength 550 nm
                if(nortau.eq.1)then
                   open(unit=13,file=dir3(1:len3)//tmat55(1:n55),
     1                  status='old')
                  read (13,1090) txt
                  read (13,1090) txt
                  read (13,1095) ifunc1,mfunc1
                  read (13,1090) txt
                  read (13,1100) wvlth5
                  read (13,1090) txt
                  read (13,1090) txt
                  read (13,1090) txt
                  read (13,1090) txt
                  read (13,1090) txt
                  read (13,1090) txt
                  read (13,1090) txt
                  read (13,1090) txt
                  read (13,1090) txt
                  read (13,1100) ccn5,bsr5,salb5,asf5,qst5,qtt5
                  wvlth5 = wvlth5*1.0e-4
                  close (13)
c                 -- compute the aerosol optical thickness for the 
c                 -- wavelength corresponding to taum55(itau) 
                  tm=(qtt/qtt5)*taum55(itau)
                  write (2,1165) qtt5,qst5
                  write (2,1170) qtt,qst
                  write(2,1175)  taum55(itau),tm
                  write(2,1177)  wvlth*1.0d4
                else
                  tm = taum55(itau)
                  write(2,1170)  qtt,qst
                  write(2,1176)  tm
                  write(2,1177)  wvlth*1.0d4
                endif
              endif
              write (2,1040)                                   
              call tauint
110           continue                                                 
              close(2)                                                
              close(3)
              close(9)                                            
              close(21)                                          
              close(23)
              rewind(5)                                               
              rewind(7)                                              
              rewind(8)                                             
              rewind(13)
            enddo
          enddo
        enddo                                                         
      enddo                                                         
c
      stop                                                              
c     -- format statements
 1000 format(3i5,7i6)
 1002 format(a)
 1003 format(2i5,4i8)
 1005 format(1p7e11.4)                                               
 1006 format(6e12.4)
c1007 format(1p7e11.4/1p7e11.4)
 1007 format(7e11.4)                                               
 1008 format(7e11.4)                                               
 1010 format(5x,7e10.3,5x)                                              
 1012 format(3e12.4)
 1015 format(1p5e15.5,5x)
 1020 format(2f10.3)
 1022 format(t5,'wvlth',t17,'psrfc',t29,'rho',t41,'xozn',t53,'tautot',
     1       t65,'deltau',t74,'nolyr')
 1023 format(1p6e12.4,i4)
 1024 format(t5,'tr',t17,'tm',t29,'ta',t41,'tcld',t53,'twat',
     1       t65,'tozn',t75,'ifc')
 1025 format(1p6e12.4,i4)
 1026 format(t3,'no',t9,'dtrr',t21,'dtmm',t33,'dtaa',t45,'dtot')
 1027 format(i4,1p4e12.4)
 1030 format(5e15.5)                                                    
 1035 format(3f10.3)                                              
 1040 format (/t5,'radiative transfer calculations based on',         
     1 ' the clear atmosphere model')                                   
 1050 format (/t5,'radiative transfer calculations based on',         
     1 ' the thin cloud model')                                         
 1060 format(4e15.5,2i5)                                                
 1065 format(2i5)
 1070 format(4e15.5)                                                    
 1090 format(a)                                                      
 1095 format(i5,11x,i5)
 1105 format(1x,'input wavelength and phase matrix wavelength'
     1       //' do not match.'/1x,'input wavelength=',1pe12.4,
     2         'phase matrix wavelength=',1pe12.4)
 1100 format(1p4e11.3,1p2e12.4)
 1120 format(1p2d18.12,1p2d19.12,0pf6.2)                                
 1130 format(i4,25f4.1)                                                 
 1140 format(i4,10f4.2)                                                 
 1165 format('volume extinction coefficient (550 nm)',t40,'=',1pe15.5,
     1  '(cm-1)'/'volume scattering coefficient (550 nm)', t40,'=',    
     2 1pe15.5, '(cm-1)'     /    )                                     
 1170 format('volume extinction coefficient',t40,'=',1pe15.5,     
     1  '(cm-1)'   /   'volume scattering coefficient', t40,'=',    
     2 1pe15.5, '(cm-1)'     /    )                                     
 1175 format('aerosol opt. thickness (550 nm)=',1pe15.5/
     1       'aerosol opt. thickness         =',1pe15.5)
 1176 format('aerosol opt. thickness         =',1pe15.5)
 1177 format('wavelength (um)                =',1pe15.5)
 1180 format(4d18.10,5x,i3)                                             
 1220 format(f5.0,4d12.4)
 1230 format(5x,f5.1,3f10.3)
      end                                                               
c
      subroutine tauint
      include 'rtinput.cmn'
c
c     write(*,*)'welcome to tauint'
c     -- set the elements to zero                                           
      do i = 1,klyr
        fa(i) = 0.0d0
        fn(i) = 0.0d0
        fr(i) = 0.0d0
        fc(i) = 0.0d0
        taum(i) = 0.0d0
        taur(i) = 0.0d0
        tauc(i) = 0.0d0
        tauozn(i)=0.0d0
        dtrr(i)=0.0
        dtmm(i)=0.0
        dtaa(i)=0.0
        dtcc(i)=0.0
      enddo
      do i=1,kmac
        lgppod(i)=dlog(ppod(i))
      enddo
      do i=1,koznp
        lgppo(i)=dlog(ppo(i))
      enddo
      const = qst/qtt                                                
      if (iair(3).eq.1) then
        x(1) = 0.0d0                                                 
        if (ioznab.eq.0) then
c         -- determine total ozone in the profile(note that the 
c         -- ozone density is gm/m**3 and the height is in km.
c         -- also, the  input is not given at equal delta height)
c         -- first determine the scale height and from it the ozone
c         -- amount above level 1
          denm  = dlog(dxd(1)/dxd(2))
          o3h   = -(htd(1)-htd(2))/denm
          xd(1) = o3h*(1.0d+3*dxd(1)/2.1429d-2)
          nm1   = kmac-1
          do i=1,nm1
            xd(i+1)=xd(i)+0.5d0*1.0d+3*(htd(i)-htd(i+1))*
     1              (dxd(i)+dxd(i+1))/2.1429d-2
          enddo
          ozamt = xd(kmac)
c         write(6,*)'ozone amount(in vpd profile)=',ozamt
          oznabs = tozn / ozamt
c         -- determine ozone optical thickness profile as a 
c         -- function of ppo (tomrad pressure levels)
          call ozn3
          toznp  = tozn
          ozamtp = ozamt
          if (toznp.gt.0d0) then
            write (2,1070) ozamtp  
          endif
        endif
        if (ioznab.ge.1)then
          x(1)=x101(1)*1.0d-3
          do i=1,kozn
            x(i+1) = x(i) + dx(i)
          enddo
          ozamt = x(koznp)
c         -- write(*,*)'ozone amount in the input profile',ozamt
c         -- determine ozone optical thickness profile as a
c         -- function of ppo
          call ozn3_abs
          toznp  = tauozn(koznp)
          ozamtp = x(koznp)
          if (toznp.gt.0d0) write (2,1070) ozamtp
        endif
      endif
      do i=1,koznp                                                    
        taua(i)=tauozn(i)
      enddo
      if (iair(2).eq.1) call part1
      if (iair(1).eq.1) then
        do i=1,koznp                                                   
          taur(i) = tr * ppo(i)                                     
        enddo
      endif
      do i=1,koznp
        tau(i)=taum(i)+taur(i)+taua(i)
      enddo
c     -- for uvb flux task divide the atmosphere with
c     -- rayleigh aerosol and ozone into 20 layers. 
c     -- redefine deltau=tau(koznp)/dfloat(20)
c     -- WE DON'T change deltau 02/14/03 :
c     -- if(tau(koznp).ge.2.0)deltau=tau(koznp)/dfloat(20)
c     -- if(tau(koznp).ge.1.0 .and. tau(koznp).lt.2.0)
c     --     deltau=tau(koznp)/dfloat(15)
c     -- if(tau(koznp).lt.1.0)deltau=tau(koznp)/dfloat(10)
      do i=1,koznp                                                  
        call linear (lgppo(i),lgppod,htd,kmac,htppo(i))
c       write(6,115)i,htppo(i),ppo(i),taur(i),taum(i),taua(i),tau(i)
      enddo
      if (tau(koznp).lt.0.02d0) deltau=tau(koznp)/2.0d0
c     -- for cloud call subroutine tau_clds and return to the main program
      write (*,*) 'KCLD',KCLD
      if (kcld.eq.1) then
        call tau_clds
      else
c       if(ioptn.eq.0)then
        ntau=tau(koznp)/deltau
        ntau=ntau+1
        dtau1=tau(koznp)/dfloat(ntau)
        write(*,*) 'NO CLOUD: dtau1=',dtau1
        ntaup=ntau+1
c       -- assign a value of 1.0e-10 fr(1),fn(1) and fa(1) (top of the atm.)
        if (taur(koznp).gt.0.0d0) fr(1) = 1.0d-10
        if (taum(koznp).gt.0.0d0) fn(1) = 1.0d-10
        if (taua(koznp).gt.0.0d0) fa(1) = 1.0d-10
        if (ifc.eq.0)fn(1) = 0.0d0
        htlvl(1) = htd(1)
        pplvl(1) = ppod(1)
        ftot(1)  = fr(1)+fn(1)+fa(1)
        do i=1,ntau                                                   
          fi   = i                                                 
          argi = fi*dtau1
          call linear (argi,tau,ppo,koznp,pp)                     
          pplvl(i+1) = pp                                        
          pplg       = dlog(pp)
          call linear(pplg,lgppo,htppo,koznp,htlvl(i+1))
          if (htlvl(i+1).lt.0.0d0) htlvl(i+1) = 0.0d0
          if (iair(1).eq.1) call linear(pp,ppo,taur,koznp,fr(i+1))
          if (iair(2).eq.1) call linear(pp,ppo,taum,koznp,fn(i+1))
          if (iair(3).eq.1) call linear(pp,ppo,taua,koznp,fa(i+1))
          ftot(i+1)=fr(i+1)+fn(i+1)+fa(i+1) 
c         write (*,1110)i,htlvl(i),pplvl(i),fr(i),fn(i),fa(i),ftot(i)        
        enddo
        write (2,1110)ntaup,htlvl(ntaup),pplvl(ntaup),fr(ntaup),
     1                fn(ntaup),fa(ntaup),ftot(ntaup)
        do i=1,ntau                                                   
          dtrr(i) = fr(i+1) - fr(i)                             
          dtmm(i) = fn(i+1) - fn(i)
          dtaa(i) = fa(i+1) - fa(i)                            
          if (dtrr(i).lt.0.0d0) dtrr(i) = 0.0d0
          if (dtmm(i).lt.0.0d0) dtmm(i) = 0.0d0
          if (dtaa(i).lt.0.0d0) dtaa(i) = 0.0d0
        enddo
        write(2,1130)                                         
        write (2,1190)                                       
        write (2,1200)                                      
      endif
      trp   = 0.0d0                                        
      tmp   = 0.0d0                                       
      tap   = 0.0d0                                      
      tcp   = 0.0d0
      nolyr = ntau
      if (kcld.eq.1) nolyr = nlyrtot
      do i=1,nolyr
        trp     = trp+dtrr(i)                                          
        tmp     = tmp+dtmm(i)                                         
        tap     = tap+dtaa(i)                                        
        tcp     = tcp+dtcc(i)
        tots    = dtrr(i)+dtmm(i)*const+dtcc(i) 
        dtot(i) = dtrr(i)+dtmm(i)+dtaa(i)+dtcc(i)                   
        salb    = tots/dtot(i)                                      
        turbhl  = (dtmm(i)*const)/tots
        write (2,1210) i,pplvl(i+1),dtrr(i),dtmm(i),dtaa(i),dtot(i),
     1                 dtcc(i),salb,turbhl 
      enddo
      tautot = trp+tmp+tap+tcp                                          
      twat   = 0.0d0              !set water vapor optical thickness=0.0
      if (kcld.eq.0) taucld = 0.0d0
      write (2,1230) trp,tmp,tap,tautot                               
      write (23,1022)
      write (23,1023) wvlth,psrfc,rrho,ozamtp,tautot,dtau1,nolyr
      write (6, 1022)                                           
      write (6, 1023) wvlth,psrfc,rrho,ozamtp,tautot,dtau1,nolyr
      write (23,1024)
      write (23,1025) trp,tmp,tap,tcp,twat,toznp,ifc
      write (23,1240)
      write(23,1250) qtt,qst
      write(23,1026)
      do i = 1,nolyr
        write(23,1027)i,htlvl(i+1),pplvl(i+1),dtrr(i),dtmm(i),
     1                dtaa(i),dtcc(i),dtot(i)
      enddo
      return                                                            
c     -- format statements
c                                                                       
 115  format(i4,1x,1p6e12.4)                                            
 121  format(t1,'tot_lvl')
 122  format(i5)
 128  format(t3,'lvl',t9,'ht(km)',t21,'p(atm)',t33,'taur',t45,'taum',
     1       t57,'taua',t69,'tau_tot')
 1000 format (15x,'total optical thickness at 3.6 km = ',1pe15.4/       
     1 15x,'new dtau=',1pe15.4/ 15x, 'new no. of layers=',i5//)         
 1010 format(/,10x,'number of layers above the cloud = ',i5,10x,        
     1 'layer thickness = ',f10.6)                                      
 1011 format(/,10x,'number of layers below the cloud = ',i5,10x,        
     1  'layer thickness = ',f10.6)                                     
 1012 format(/,10x,'number of layers in the cloud = ',i5,10x,           
     1  'layer thickness = ',f10.6)                                     
 1015 format (1x,t50,'clear atmosphere')                                
 1016 format (1x,t50,'thin cloud')                                      
 1017 format (1x,t50,'thick cloud')                                     
 1020 format (/,t50,'cumulative optical thicknesses'///t11,             
     1 'press.',t27,'rayleigh', t47, 'mie',t67,'ozone',t87,'total'/     
     2 t11,'(in atm)'/)                                                 
 1022 format(t5,'wvlth',t17,'psrfc',t29,'rho',t41,'xozn',t53,'tautot',
     1       t65,'deltau',t74,'nolyr')
 1023 format(1p6e12.4,i4)
 1024 format(t5,'tr',t17,'tm',t29,'ta',t41,'tcld',t53,'twat',
     1       t65,'tozn',t75,'ifc')
 1025 format(1p6e12.4,i4)
 1026 format(t3,'no',t9,'htl_b',t21,'pl_b',t33,'dtrr',t45,'dtmm',
     1       t57,'dtaa',t69,'dtcc',t81,'dtot')
 1027 format(i4,1p7e12.4)
 1030 format (5x,'delta tau =',1pe15.5,5x,'no. of layers =',i3/)   
 1040 format ('interpolated values of press  and',
     1 ' tau(rayleigh) etc. corresponding to'/'delta tau=',1pe15.5// 
     2 t10,'height',t23,'press.',t31,'tau(rayleigh)',t46, 'tau(mie)',
     3 t56,'tau(ozone)',t68,'tau(tot)'/t10,'(in km)',t22,'(in atm)'/)  
 1050 format ('values of tau(rayleigh) etc. in full and half layers'/
     1'(the first and the last layer are half layers)'/)
 1060 format (//t15,'division of atmosphere into layers of equal optical
     1 thickness for pupose of calculating radiative transfer:'//)      
 1070 format (15x,'total ozone(top to psrfc) in atm-cm',1pe15.5/)      
 1080 format (i4,1x,1p6e12.4)                                           
 1090 format (i3,2x,1p4e11.3,0pf8.4)                                  
 1100 format (t2,'no',t8,'dtau(ray)',t19,'dtau(mie)',t30,           
     1 ' dtau(o3)',t41,'dtau(tot)',t53,'turb'/)  
 1110 format (i4,1x,1p6e12.4)                                           
 1120 format (3e15.5)                                                   
 1130 format ('    ')                                                 
 1140 format (t10,'sum of the total dtau = ',f10.5,                 
     1 /t10,'sum of the total dtaur       = ', f10.5,                   
     2 /t10,'sum of the total dtaum(scat.)= ', f10.5,                  
     3 /t10,'sum of the total dtaua       = ', f10.5)                  
 1190 format(/t5,'values of tau(rayleigh ) etc. in each layer'/) 
 1200 format(t2,'no',t6,'press(atm)',t17,'dtau(ray)',t28,             
     1 'dtau(mie)',t39, 'dtau(o3)',t49,' dtau(tot)',              
     2  t60,'alb_sscat',t71,'turb'/)                                 
 1210 format(i3,1p6e11.3,0p2f8.4)                                   
 1230 format(/t10,'tau_r        =',e12.4/t10,'tau_m        =',e12.4/ 
     1       t10,'tau_a        =',e12.4/t10,'tau_t        =',e12.4) 
 1240 format(t5,'qs',t17,'qt')
 1250 format(1p2e12.4)
      end
c
      subroutine ozn3
      include 'rtinput.cmn'
      real*8 ee(koznp),uu(koznp)
      in = 1
      il = 1
      iu = 1
      do i = 1,koznp
        call spline(ppo(i),ppod,xd,n,in,tempo3,il,iu,vl,vu,ee,uu)
        tauozn(i)=tempo3*oznabs
      enddo
      return
      end
c
      subroutine linear(xp,x,y,n,yp)                                    
c     -- subroutine performs linear interpolation.  It assumes that        
c     -- x is a monotonically increasing parameter                         
      implicit real*8 (a-h,o-z)
      real*8 x(n),y(n)                                                  
c                                                                       
      il = 1                                                           
      ih = n                                                          
100   continue                                                       
      m = (il+ih) / 2                                               
      if (xp.gt.x(m)) then                                         
        il = m                                                    
      else                                                       
        ih = m                                                  
      endif                                                    
      id = ih - il                                            
      if (id.eq.1) goto 200                                  
      goto 100                                              
200   continue                                             
      slope = (y(ih)-y(il))/(x(ih)-x(il))                 
      yp    = y(il)+slope*(xp-x(il))                     
      return                                            
      end                                                               
      subroutine spline(s,x,y,n,in,t,il,iu,vl,vu,e,u)                   
c     -- x,y array of ind. & depen. var.,s the argument to be interpolated 
c     -- t the interpolated value,n the dimension of (x,y)                 
c     -- in=1 determines spline func,in=2 interpolates spline fnc          
c     -- il,iu=1 parabolic runout conditions at lower & upper bound.       
c     -- il,iu=2 1st derivative  (vl,vu) at lower or upper bound resp.     
c     -- il,iu=3 2nd derivative  (vl,vu) at lower or upper bound resp.     
c
      implicit real*8 (a-h,o-z)
      dimension x(2), y(2), e(2),u(2)                                   
      goto (10,40),in                                                  
   10 continue                                                          
      n1 = n-1                                                       
      b1 = x(2)-x(1)                                               
      c1 = (y(2)-y(1))/b1                                         
      goto (12,14,16),il                                               
   12 e(1) = 1.0d0                                               
      u(1) = 0.0d0                                              
      go to 18                                                          
   14 e(1) = -.5d0                                             
      u(1) = (c1-vl)/2.0d0/b1                                 
      go to 18                                                          
   16 e(1) = 0                                               
      u(1) = vl/12.0d0                                      
   18 continue                                                          
      do 20 j=2,n1                                                      
      b2   = x(j+1)-x(j)                                   
      c2   = (y(j+1)-y(j))/b2                             
      b    = x(j+1)-x(j-1)                               
      d    = (c2-c1)/b                                  
      c    = b1/b                                                     
      b1   = b2                                                      
      c1   = c2                                                     
      p    = c*e(j-1)+2.0d0                                        
      e(j) = (c-1.0d0)/p                                          
   20 u(j) = (d-c*u(j-1))/p                                      
      goto (22,24,26),iu                                               
   22 continue                                                          
      e(n) = u(n1)/(1.0d0-e(n1))                                
      go to 28                                                          
   24 c2   = vu-(y(n)-y(n1))/(x(n)-x(n1))                            
      e(n) = (c2/(x(n)-x(n1))-u(n1))/(2.0d0+e(n1))                  
      go to 28                                                     
   26 e(n) = vu/12.0d0                                            
   28 continue                                                   
      do 30 kk = 1,n1                                           
      k = n-kk                                                 
      e(k) = e(k)*e(k+1)+u(k)                                       
c     -- to obtain the derivatives at the knots remove c from the          
c     -- following comments cards.then the array u will contain            
c     -- the derivatives of the spline function at the knots               
      b2   = x(k+1)-x(k)                                               
      u(k) = (y(k+1)-y(k))/b2-b2*(e(k)*2+e(k+1))                      
   30 continue                                                       
      b2   = x(n)-x(n1)                                             
      u(n) = (e(n1)+2.0d0*e(n))*b2+(y(n)-y(n1))/b2                 
   40 if (x(1).gt.x(n)) go to 50                                  
      idir  = 0                                                  
      mlb   = 0                                                 
      mub   = n                                                
      goto 60                                                 
   50 idir  = 1                                                       
      mlb   = n                                                      
      mub   = 0                                                     
   60 if (s.ge.x(mub+idir)) goto 100                                   
      if (s.le.x(mlb+1-idir)) goto 110                                 
      ml    = mlb                                                  
      mu    = mub                                                 
      goto 80                                                    
   70 if (iabs(mu-ml).le.1) goto 120                            
   80 mav   = (ml+mu)/2                                        
      if (s.lt.x(mav)) goto 90                                
      ml    = mav                                            
      goto 70                                               
   90 mu    = mav                                          
      goto 70                                             
  100 mu    = mub+2*idir                                 
      goto 130                                                         
  110 mu    = mlb+2*(1-idir)                                          
      goto 130                                                       
  120 mu    = mu+idir                                               
130   continue                                                     
      t = (e(mu-1)*((x(mu)-s)**3)+e(mu)*((s-x(mu-1))**3)+         
     1    (y(mu-1)-e(mu-1)*((x(mu)-x(mu-1))**2))*(x(mu)-s)+      
     2    (y(mu)-e(mu)*((x(mu)-x(mu-1))**2))*(s-x(mu-1)))/      
     3    (x(mu)-x(mu-1))                                      
       return                                                 
       end                                                              
c
      subroutine part1
      include 'rtinput.cmn'
c     -- determine the geo. height and num. density corresponding to pdv
c     write(6,*)'welcome to part1'
      do i = 1,kozn
        do j = 1,kmac-1
          if (ppo(i).ge.ppod(j) .and. ppo(i).lt.ppod(j+1)) then
            xn1    = dlog(ppo(i))-dlog(ppod(j))
            xd1    = dlog(ppod(j+1))-dlog(ppod(j))
            hho(i) = htd(j)+(xn1/xd1)*(htd(j+1)-htd(j))
            prod1  = (hho(i)-htd(j))/(htd(j+1)-htd(j))
            if (znp(j).gt.0.0) then
              zpp(i) = znp(j)*(znp(j+1)/znp(j))**prod1
            else
              zpp(i) = 0.0d0
            endif
          endif
        enddo
        hho(koznp)=0.0d0
        zpp(koznp)=znp(kmac)
c       write(6,226)i,pdv(i),hho(i),zpp(i)
226     format('i,pdv,hho,zpp',i3,1x,1p3e11.3)
      enddo
c     -- integrate the number density
      zppt(1) = 0.0d0
      do i = 1,koznp-1
        dnm(i)    = 0.5d0*(zpp(i)+zpp(i+1))*(hho(i)-hho(i+1))*1.0d+5
        zppt(i+1) = zppt(i)+dnm(i)
      enddo
c     -- convert the total number of particles in to optical depth
      tp = zppt(koznp)*qtt
c     -- scale the optical depth 'tp' to the input value 'tm'
      c = tm/tp
      do i = 1,koznp
        taum(i) = c * zppt(i) * qtt
      enddo
      return
      end
c
      subroutine dust_prof
      include 'rtinput.cmn'
      do i = 1,nm
        znpdd(i) = exp(-0.5d0*((htdd(i)-ht_dust)/sigma_dust)**2)
      enddo
      return
      end
c
      subroutine ozn3_abs 
c     -- modifications
c       20060715 - changes in subroutine ozn3_abs to avoid small taa in lowest layers
c     -- problems
c       20060715 - There is still one problem. For some reason , the program makes the
c                  bottom two layers identical.
      include 'rtinput.cmn'
      real*8 ee(klyr),uu(klyr)
c     -- determine the ozone optical thickness using temperature 
c     -- dependent coefficient. if ioznab=1 then set temp. at all
c     -- levels to 227.16k (-46.0 c)
      if (ioznab.eq.1) then
        do i = 1,koznp
          temp101(i) = 227.16
        enddo
      endif
      tozn101(1) = 0.0d0                
      tauozn(1)  = 0.0d0
      do i = 1,kozn
c     do i=2,koznp
        alfatemp = cc0+cc1*(0.5d0*(temp101(i)+temp101(i+1))-273.16)+
     1             cc2*(0.5d0*(temp101(i)+temp101(i+1))-273.16)**2.0
        tozn101(i+1) = tozn101(i)+alfatemp*dx(i) 
        tauozn(i+1)  = tozn101(i+1)
      enddo
      return
      end
      subroutine convtc (num,nchar, loc)                                
c     -- library subroutine                                                   
c     -- module name: convtc                                                  
c     -- version    : 1.0                                                     
c     -- purpose: to convert first nchar digits of an integer into a character
c     --          or a string. (note: nchar doesn't include the sign if num   
c     --          is negative)                                                
c     -- calling sequence: convtc (num,nchar, loc)                            
c     -- subroutines called: none                                             
c     -- intrinsic functions used: char, ichar, iabs                          
c     -- common blocks used: none                                             
c     -- arguments and local variables:                                       
c     --     name    type  i/o  descriptions                                  
c         ---------  ----  ---  ----------------------------------------------
c         num        i*4    i   integer number for conversion                 
c         nchar      i*4    i   number of chars to be converted               
c         loc        c*x    o   char variable or array (string)               
c         istart     i*4        start position of integral char string:       
c                               1 for positive integer; 2 for negative integer
c         irem       i*4        absolute value or remainder by 10             
c         itemp      i*4        temporary buffer                              
c     -- arguments                                                         
      integer   num, nchar                                              
      character loc(1)                                                  
c     -- local variables                                                   
      integer   istart, irem, itemp                                     
      irem   = iabs (num )                                   
      istart = 1                                                        
c     -- keep the sign if the integer is negative                          
      if (num.lt.0) then                                                
        nchar  = nchar + 1                                              
        loc(1) = '-'                                                   
        istart = istart + 1                                            
      endif                                                             
c     -- convert digit by digit starting with the least significant digit  
      do 100 i = nchar, istart, -1                                      
        itemp  = irem / 10                                              
        loc(i) = char (irem - itemp * 10 + ichar('0'))                 
        irem   = itemp                                      
 100  continue                                                          
c     -- put an asterisk at the first position if the actual number of     
c     -- digits in the integer is found greater than nchar                 
      if (irem.ne.0) loc(1) = '*'                                       
      return                                                            
      end                                                               
c
      subroutine tau_clds
c     -- subroutine tau_clds constructs the layers for RT calculations
c     -- in the presence of clouds
      include 'rtinput.cmn'
      real*8 e(koznp),u(koznp)
c     write(*,*)'welcome to tau_clds'
      in = 1
      il = 1
      iu = 1
c     -- find the total optical thickness corresponding to cloud top
c     -- pressure
      call spline(pcldtop,ppo,tau,koznp,in,tptop,il,iu,vl,vu,e,u)
c     -- find the number of layers upto pressure pcldtop
      nx  = tptop/deltau
      nx  = nx+1
      dtx = tptop/dfloat(nx)
c     -- calculate the no. of cloud layers from pcldtop to pcldbtm
      ntaucld = taucld/dltcld
      ntaucld = ntaucld + 1
      dtaucld = taucld/dfloat(ntaucld)
c     -- find the total optical thickness corresponding to cloud bottom
c     -- pressure and determine the total optical thickness of the 
c     -- atmospheric constituents in the layer
      call spline(pcldbtm,ppo,tau,koznp,in,tpbtm,il,iu,vl,vu,e,u)
      dtcld_atm = (tpbtm-tptop)/dfloat(ntaucld)
c     -- calculate the number of layers from the cloud bottom to the 
c     -- psrfc 
      taubtm = (tau(koznp)-tpbtm)
      if (taubtm.lt.deltau) then
        dtaubtm = taubtm/2.0d0
      else
        dtaubtm = deltau
      endif
      ny  = (tau(koznp)-tpbtm)/dtaubtm
      ny  = ny+1
      dty = taubtm/dfloat(ny)
c     -- find the optical thickness of each constituent
c     -- assign a value of 1.0e-10 fr(1),fn(1) and fa(1) (top of the atm.)
      if (taur(koznp).gt.0.0d0) fr(1) = 1.0d-10
      if (taum(koznp).gt.0.0d0) fn(1) = 1.0d-10
      if (taua(koznp).gt.0.0d0) fa(1) = 1.0d-10
      if (ifc.eq.0)fn(1) = 0.0d0
      htlvl(1) = htd(1)
      pplvl(1) = ppod(1)
      ftot(1)  = fr(1)+fn(1)+fa(1)
      dtlx     = 0.0d0
      nlyrtot  =  nx+ntaucld+ny
      do i = 1,nlyrtot
        if (i.le.nx) dtlyrz = dtx
        if (i.gt.nx .and. i.le.(nx+ntaucld)) dtlyrz = dtcld_atm
        if (i.gt.(nx+ntaucld)) dtlyrz = dty
        dtlx = dtlx+dtlyrz
c       write(*,*)'i,dtlx',i,dtlx
        call linear (dtlx,tau,ppo,koznp,pp)
        pplvl(i+1) = pp
        pplg       = dlog(pp)
        call linear(pplg,lgppo,htppo,koznp,htlvl(i+1))
        if (htlvl(i+1).lt.0.0d0)htlvl(i+1)=0.0d0
        if (iair(1).eq.1) call linear(pp,ppo,taur,koznp,fr(i+1))
        if (iair(2).eq.1) call linear(pp,ppo,taum,koznp,fn(i+1))
        if (iair(3).eq.1) call linear(pp,ppo,taua,koznp,fa(i+1))
        if (i.gt.nx .and. i.le.(nx+ntaucld)) then
         fc(i+1) = fc(i)+dtaucld
        endif
        ftot(i+1) = fr(i+1)+fn(i+1)+fa(i+1)+fc(i+1)
c       write (*,1110) i,htlvl(i),pplvl(i),fr(i),fn(i),fa(i),
c    1                 fc(i),ftot(i)
      enddo
c        write (*,1110) i,htlvl(nlyrtot+1),pplvl(nlyrtot+1),
c    1                  fr(nlyrtot+1),fn(nlyrtot+1),fa(nlyrtot+1),
c    2                  fc(nlyrtot+1),ftot(nlyrtot+1)
c
      do i = 1,nlyrtot
        dtrr(i) = fr(i+1) - fr(i)
        dtmm(i) = fn(i+1) - fn(i)
        dtaa(i) = fa(i+1) - fa(i)
        dtcc(i) = fc(i+1) - fc(i)
        if (dtrr(i).lt.0.0d0) dtrr(i) = 0.0d0
        if (dtmm(i).lt.0.0d0) dtmm(i) = 0.0d0
        if (dtaa(i).lt.0.0d0) dtaa(i) = 0.0d0
        if (dtcc(i).lt.0.0d0) dtcc(i) = 0.0d0
      enddo
c     write(*,*)'leaving tau_cld'
      return
 1110 format (i3,1x,1p7e11.3)
      end
